#ifndef HEADER_MULTILINE_MACRO
#define HEADER_MULTILINE_MACRO

/*
 * Header providing wrappers for multiline macros. Intended to suppress
 * "C4127: conditional expression is constant"
 * warnings generated by do {...} while(0) macros.
 */

#define MULTI_LINE_MACRO_BEGIN do {

#ifdef _MSC_VER
#define MULTI_LINE_MACRO_END \
    __pragma(warning(push)) \
    __pragma(warning(disable:4127)) \
    } while(0) \
    __pragma(warning(pop))
#else
#define MULTI_LINE_MACRO_END \
    } while(0)
#endif

#endif // HEADER_MULTILINE_MACRO
